(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-camera', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-camera'] = {}, global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, core, rxjs, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var CameraUtil = /** @class */ (function () {
        function CameraUtil() {
        }
        CameraUtil.getAvailableCameraInputs = function () {
            var sub = new rxjs.Subject();
            if (!navigator.mediaDevices || !navigator.mediaDevices.enumerateDevices) {
                sub.error('.enumerateDevices method  not supported.');
                return sub.asObservable();
            }
            navigator.mediaDevices.enumerateDevices()
                .then(function (devices) {
                sub.next(devices.filter(function (device) { return device.kind === 'videoinput'; }));
            })
                .catch(function (err) {
                sub.next(err.message || err);
            });
            return sub.asObservable();
        };
        return CameraUtil;
    }());

    var NgxCameraComponent = /** @class */ (function () {
        function NgxCameraComponent() {
            /** camera area width */
            this.width = 640;
            /** camera area height */
            this.height = 480;
            /** define camera image type */
            this.imageType = exports.CameraImageType.jpeg;
            /** should start camera in after view init or not */
            this.startCam = true;
            /** define camera image quality */
            this.imageQuality = 0.9;
            /** event emitter for detected devices */
            this.detectedDevices = new core.EventEmitter();
            /** event emitter for captured video stream */
            this.stream = new core.EventEmitter();
            /** event emitter for errors occord at diffrent stages */
            this.errorStream = new core.EventEmitter();
            /** event emitter for errors occord at diffrent stages */
            this.imageCapture = new core.EventEmitter();
            /** available camera inputs list */
            this.availableCameraInputs = [];
            /** if video os initialized or not */
            this.videoInitialized = false;
        }
        NgxCameraComponent_1 = NgxCameraComponent;
        Object.defineProperty(NgxCameraComponent.prototype, "clear", {
            /**
             * If the given Observable emits, clear canvas
             */
            set: function (clear) {
                var _this = this;
                if (this.clearSubscription) {
                    this.clearSubscription.unsubscribe();
                }
                // Subscribe to events from this Observable to take snapshots
                this.clearSubscription = clear.subscribe(function () {
                    var _canvas = _this.canvas.nativeElement;
                    var context2d = _canvas.getContext('2d');
                    context2d.clearRect(0, 0, _canvas.width, _canvas.height);
                });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCameraComponent.prototype, "trigger", {
            /**
             * If the given Observable emits, an image will be captured and emitted through 'imageCapture' EventEmitter
             */
            set: function (trigger) {
                var _this = this;
                if (this.triggerSubscription) {
                    this.triggerSubscription.unsubscribe();
                }
                // Subscribe to events from this Observable to take snapshots
                this.triggerSubscription = trigger.subscribe(function () {
                    _this.takeSnapshot();
                });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCameraComponent.prototype, "switchCamera", {
            /**
             * If the given Observable emits, the active webcam will be switched to the one indicated by the emitted value.
             * @param switchCamera Indicates which webcam to switch to
             *   MediaDeviceInfo: activate the webcam with the given  MediaDeviceInfos
             */
            set: function (switchCamera) {
                var _this = this;
                if (this.cameraSwitcherSubscription) {
                    this.cameraSwitcherSubscription.unsubscribe();
                }
                // Subscribe to events from this Observable to switch video device
                this.cameraSwitcherSubscription = switchCamera.subscribe(function (value) {
                    if (value instanceof MediaDeviceInfo) {
                        _this.switchToVideoInput(value);
                    }
                });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgxCameraComponent.prototype, "VideoElement", {
            /**
             * get native html element from video elementeRef
             * @returns native html element from video elementeRef
             */
            get: function () {
                return this.video.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * method to return MediaTrackConstraints from device id and baseMediaTrackConstraints
         * @param deviceId device id to merge MediaTrackConstraints with. you can pass null if you just want to get MediaTrackConstraints.
         * @param baseMediaTrackConstraints MediaTrackConstraints to merge with or you can use this getter ot get default MediaTrackConstraints bu passing null.
         * @returns merged MediaTrackConstraints from given device id and baseMediaTrackConstraints
         */
        NgxCameraComponent.getMediaConstraintsForDevice = function (deviceId, baseMediaTrackConstraints) {
            var contstraints = baseMediaTrackConstraints ? baseMediaTrackConstraints : NgxCameraComponent_1.DEFAULT_VIDEO_OPTIONS;
            if (deviceId) {
                contstraints.deviceId = { exact: deviceId };
            }
            return contstraints;
        };
        NgxCameraComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            // detect availabe device and start camera if any device is found;
            this.detectAvailableDevices().subscribe(function (inputs) {
                if (_this.startCamera) {
                    if (inputs.length > 0) {
                        _this.switchToVideoInput(inputs[0]);
                    }
                }
            });
        };
        /**
         * allows you to switch to a spicific camera
         * @param info media info of device that you want to switch camera to
         */
        NgxCameraComponent.prototype.switchToVideoInput = function (info) {
            this.videoInitialized = false;
            this.stopMediaTracks();
            var videoConstraints = NgxCameraComponent_1.getMediaConstraintsForDevice(info.deviceId, NgxCameraComponent_1.DEFAULT_VIDEO_OPTIONS);
            this.initWebcam(info.deviceId, videoConstraints);
        };
        /**
         * start a camera with particular device id
         * @param deviceId device id to start camera on
         */
        NgxCameraComponent.prototype.startCamera = function (deviceId) {
            this.videoInitialized = false;
            this.initWebcam(deviceId, NgxCameraComponent_1.DEFAULT_VIDEO_OPTIONS);
        };
        /**
         * list all the detected media device with kind video input
         * @returns observable of detected media devices after promis is resolved
         */
        NgxCameraComponent.prototype.detectAvailableDevices = function () {
            var _this = this;
            var sub = new rxjs.Subject();
            CameraUtil.getAvailableCameraInputs().subscribe(function (inputs) {
                _this.detectedDevices.emit(inputs);
                sub.next(inputs);
            });
            return sub.asObservable();
        };
        /**
         *  initinitialize web cam with device id and constraints and assign all the data streams to respective variables.
         * @param deviceId device id to initinitialize web cam on
         * @param userVideoTrackConstraints user video track constraints.
         */
        NgxCameraComponent.prototype.initWebcam = function (deviceId, userVideoTrackConstraints) {
            var _this = this;
            var video = this.VideoElement;
            if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
                var videoConstraints = NgxCameraComponent_1.getMediaConstraintsForDevice(deviceId, userVideoTrackConstraints);
                navigator.mediaDevices.getUserMedia({ video: videoConstraints })
                    .then(function (stream) {
                    console.log(stream);
                    _this.videoInitialized = true;
                    video.srcObject = stream;
                    _this.mediaStream = stream;
                    video.play();
                });
            }
        };
        /**
         * stops all the media tracks
         */
        NgxCameraComponent.prototype.stopMediaTracks = function () {
            if (this.mediaStream && this.mediaStream.getTracks) {
                // getTracks() returns all media tracks (video+audio)
                this.mediaStream.getTracks()
                    .forEach(function (track) { return track.stop(); });
            }
        };
        /**
         * Takes a snapshot of the current webcam's view and emits the image as an event
         */
        NgxCameraComponent.prototype.takeSnapshot = function () {
            // set canvas size to actual video size
            var _video = this.VideoElement;
            var dimensions = { width: this.width, height: this.height };
            if (_video.videoWidth) {
                dimensions.width = _video.videoWidth;
                dimensions.height = _video.videoHeight;
            }
            var _canvas = this.canvas.nativeElement;
            _canvas.width = dimensions.width;
            _canvas.height = dimensions.height;
            // paint snapshot image to canvas
            var context2d = _canvas.getContext('2d');
            context2d.drawImage(_video, 0, 0);
            // read canvas content as image
            var mimeType = this.imageType ? this.imageType : 'image/png';
            var quality = this.imageQuality ? this.imageQuality : 0.9;
            var dataUrl = _canvas.toDataURL(mimeType, quality);
            // get the ImageData object from the canvas' context.
            var imageData = null;
            if (this.captureImageData) {
                imageData = context2d.getImageData(0, 0, _canvas.width, _canvas.height);
            }
            console.log(dataUrl);
            this.imageCapture.next(new CameraImage(dataUrl, mimeType, imageData));
        };
        var NgxCameraComponent_1;
        /** default video options */
        NgxCameraComponent.DEFAULT_VIDEO_OPTIONS = { aspectRatio: 1, height: 480, width: 640, facingMode: 'user' };
        __decorate([
            core.ViewChild('video', { static: true })
        ], NgxCameraComponent.prototype, "video", void 0);
        __decorate([
            core.ViewChild('canvas', { static: true })
        ], NgxCameraComponent.prototype, "canvas", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "width", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "height", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "imageType", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "startCam", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "imageQuality", void 0);
        __decorate([
            core.Output()
        ], NgxCameraComponent.prototype, "detectedDevices", void 0);
        __decorate([
            core.Output()
        ], NgxCameraComponent.prototype, "stream", void 0);
        __decorate([
            core.Output()
        ], NgxCameraComponent.prototype, "errorStream", void 0);
        __decorate([
            core.Output()
        ], NgxCameraComponent.prototype, "imageCapture", void 0);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "clear", null);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "trigger", null);
        __decorate([
            core.Input()
        ], NgxCameraComponent.prototype, "switchCamera", null);
        NgxCameraComponent = NgxCameraComponent_1 = __decorate([
            core.Component({
                selector: 'ngx-camera',
                template: "<div class=\"canvas-wrapper\" [ngStyle]=\"{'width': width+'px','height': height+'px'}\">\r\n  <video #video [width]='width' [height]=\"height\"></video>\r\n  <canvas #canvas></canvas>\r\n</div>\r\n",
                styles: [".canvas-wrapper{position:relative}.canvas-wrapper canvas,.canvas-wrapper video{position:absolute;top:0;left:0}"]
            })
        ], NgxCameraComponent);
        return NgxCameraComponent;
    }());
    var WebcamMirrorProperties;
    (function (WebcamMirrorProperties) {
        WebcamMirrorProperties["auto"] = "auto";
        WebcamMirrorProperties["always"] = "always";
        WebcamMirrorProperties["never"] = "never"; // ["auto", "always", "never"]
    })(WebcamMirrorProperties || (WebcamMirrorProperties = {}));

    (function (CameraImageType) {
        CameraImageType["jpeg"] = "image/jpeg";
        CameraImageType["png"] = "image/png";
    })(exports.CameraImageType || (exports.CameraImageType = {}));
    var CameraImage = /** @class */ (function () {
        function CameraImage(imageAsDataUrl, mimeType, imageData) {
            this._mimeType = null;
            this._imageAsBase64 = null;
            this._imageAsDataUrl = null;
            this._imageData = null;
            this._mimeType = mimeType;
            this._imageAsDataUrl = imageAsDataUrl;
            this._imageData = imageData;
        }
        /**
         * Extracts the Base64 data out of the given dataUrl.
         * @param dataUrl the given dataUrl
         * @param mimeType the mimeType of the data
         */
        CameraImage.getDataFromDataUrl = function (dataUrl, mimeType) {
            return dataUrl.replace("data:" + mimeType + ";base64,", '');
        };
        Object.defineProperty(CameraImage.prototype, "imageAsBase64", {
            /**
             * Get the base64 encoded image data
             * @returns base64 data of the image
             */
            get: function () {
                return this._imageAsBase64 ? this._imageAsBase64
                    : this._imageAsBase64 = CameraImage.getDataFromDataUrl(this._imageAsDataUrl, this._mimeType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CameraImage.prototype, "imageAsDataUrl", {
            /**
             * Get the encoded image as dataUrl
             * @returns the dataUrl of the image
             */
            get: function () {
                return this._imageAsDataUrl;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CameraImage.prototype, "imageData", {
            /**
             * Get the ImageData object associated with the canvas' 2d context.
             * @returns the ImageData of the canvas's 2d context.
             */
            get: function () {
                return this._imageData;
            },
            enumerable: true,
            configurable: true
        });
        return CameraImage;
    }());

    var NgxCameraModule = /** @class */ (function () {
        function NgxCameraModule() {
        }
        NgxCameraModule = __decorate([
            core.NgModule({
                declarations: [NgxCameraComponent],
                imports: [
                    common.CommonModule
                ],
                exports: [NgxCameraComponent]
            })
        ], NgxCameraModule);
        return NgxCameraModule;
    }());

    exports.CameraImage = CameraImage;
    exports.CameraUtil = CameraUtil;
    exports.NgxCameraComponent = NgxCameraComponent;
    exports.NgxCameraModule = NgxCameraModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-camera.umd.js.map
